#include "ExpTradeSummarySingle.mqh"

#define UINT uint
#define INT64 datetime

//+------------------------------------------------------------------+
//|     -                 |
//+------------------------------------------------------------------+
struct ExpTradeSummaryExt : public ExpTradeSummarySingle
{
private:
  string LengthToString( const datetime Length ) const
  {
    const int Days = (int)(Length / (24 * 3600));

    return(((Days) ? (string)Days + "d ": "") + ::TimeToString(Length, TIME_SECONDS));
  }

public:
  int               Offset2[18];
  double            ghpr;                    //   
  double            ghprpercent;             //     
  double            ahpr;                    //   
  double            ahprpercent;             //     
  double            zscore;                  //  
  double            zscorepercent;           //    
  double            lrcorr;                  //    
  double            lrstderror;              //       
  UINT              symbols;                 //     
  int               Offset3;
  double            corr_prf_mfe;            //   mfe  profit
  double            corr_prf_mae;            //   mae  profit
  double            corr_mfe_mae;            //   mae  mfe
  double            mfe_a;                   //   mfe  profit, .    
  double            mfe_b;                   //   mfe  profit, .    
  double            mae_a;                   //   mae  profit, .    
  double            mae_b;                   //   mae  profit, .    
  UINT              in_per_hours[24];        //    
  UINT              in_per_week_days[7];     //     
  UINT              in_per_months[12];       //    
  int               Offset4;
  double            out_per_hours[24][2];    //    
  double            out_per_week_days[7][2]; //     
  double            out_per_months[12][2];   //    
  INT64             holding_time_min;        //    
  INT64             holding_time_max;        //    
  INT64             holding_time_avr;        //    

#define TOSTRING(A) #A + " = " + (string)(A) + "\n"
#define TOSTRING2(A) #A + " = " + this.LengthToString(A) + "\n"

  string ToString( void ) const
  {
    return(ExpTradeSummarySingle::ToString() +
           TOSTRING(ghpr) +                  //   
           TOSTRING(ghprpercent) +           //     
           TOSTRING(ahpr) +                  //   
           TOSTRING(ahprpercent) +           //     
           TOSTRING(zscore) +                //  
           TOSTRING(zscorepercent) +         //    
           TOSTRING(lrcorr) +                //    
           TOSTRING(lrstderror) +            //       
           TOSTRING(symbols) +               //     
           TOSTRING(corr_prf_mfe) +          //   mfe  profit
           TOSTRING(corr_prf_mae) +          //   mae  profit
           TOSTRING(corr_mfe_mae) +          //   mae  mfe
           TOSTRING(mfe_a) +                 //   mfe  profit, .    
           TOSTRING(mfe_b) +                 //   mfe  profit, .    
           TOSTRING(mae_a) +                 //   mae  profit, .    
           TOSTRING(mae_b) +                 //   mae  profit, .    
           TOSTRING2(holding_time_min) +     //    
           TOSTRING2(holding_time_max) +     //    
           TOSTRING2(holding_time_avr));     //    
  }

#undef TOSTRING2
#undef TOSTRING
};

#undef INT64
#undef UINT