#include "String.mqh"

#define UINT uint
#define DWORD int
#define INT64 datetime

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
struct SingleTestCacheHeader
{
  UINT              version;                //   502
//  wchar_t           copyright[64];          // 
  STRING64          copyright    ;          // 
//  wchar_t           name[16];               //   "SingleTestCache"
  STRING16          name;                   //   "SingleTestCache"
  int               head_reserve[66];
  //---
  UINT              header_size;            //     header_size   
  //---
//  wchar_t           expert_name[64];        //  
  STRING64          expert_name;            //  
//  wchar_t           expert_path[128];       //      MQL5
  STRING128         expert_path;            //      MQL5
//  wchar_t           server[64];             //   ( )
  STRING64          server;                 //   ( )
//  wchar_t           symbol[32];             //  
  STRING32          symbol    ;             //  
  int               period;                 //  
  int               ticks_mode;             //   
  INT64             date_from;              //      
  INT64             date_to;                //     
  INT64             date_forward;           //    
  DWORD             msc_last;               //    
  DWORD             msc_min;                //     
  DWORD             msc_max;                //     
  DWORD             msc_avg;                //     
  UINT              tests_passed;           //   
  int               common_reserve[16];
  //---
//  wchar_t           group[80];              //   + hedging/netting
  STRING80          group;                  //   + hedging/netting
//  wchar_t           trade_currency[32];     //  
  STRING32          trade_currency    ;     //  
  int               trade_deposit;          //  
  int               trade_condition;        //    (0- , -1- , nnn- )
  int               trade_leverage;         // 
  int               trade_hedging;          // 1 - netting, 2 - hedging
  int               trade_currency_digits;  //        
  int               trade_pips;             //   
  int               trade_reserve[8];
  //---
  UINT              deals_total;
  UINT              orders_total;
  UINT              positions_total;
  UINT              equities_total;
  int               results_reserve[3];
  //---
  char              hash_ex5[16];           //    
  UINT              parameters_size;        //    
  UINT              parameters_total;       //  
  //     
  //---  .   ExpTradeSummary, ExpTradeSummaryExt, ,   ,   ( )

#define TOSTRING(A) #A + " = " + (string)(this.A) + "\n"
#define TOSTRING2(A) #A + " = " + ::EnumToString(A) + "\n"
#define TOSTRING3(A) #A + " = " + this.A[] + "\n"

  string ToString( void ) const
  {
    return(
           TOSTRING(version) +                //  
           TOSTRING3(copyright) +             // 
           TOSTRING3(name) +                  //   "SingleTestCache"
           TOSTRING(header_size) +            //  
           TOSTRING3(expert_name) +           //  
           TOSTRING3(expert_path) +           //      MQL5
           TOSTRING3(server) +                //   ( )
           TOSTRING3(symbol) +                //  
           TOSTRING2((ENUM_TIMEFRAMES)period) +                //  
           TOSTRING(ticks_mode) +             //   
           TOSTRING(date_from) +              //      
           TOSTRING(date_to) +                //     
           TOSTRING(date_forward) +           //    
           TOSTRING(msc_last) +               //    
           TOSTRING(msc_min) +                //     
           TOSTRING(msc_max) +                //     
           TOSTRING(msc_avg) +                //     
           TOSTRING(tests_passed) +           //   
           TOSTRING3(group) +                 //   + hedging/netting
           TOSTRING3(trade_currency) +        //  
           TOSTRING(trade_deposit) +          //  
           TOSTRING(trade_condition) +        //    (0- , -1- , nnn- )
           TOSTRING(trade_leverage) +         // 
           TOSTRING(trade_hedging) +          // 1 - netting, 2 - hedging
           TOSTRING(trade_currency_digits) +  //        
           TOSTRING(trade_pips) +             //   
           TOSTRING(deals_total) +
           TOSTRING(orders_total) +
           TOSTRING(positions_total) +
           TOSTRING(equities_total) +
           TOSTRING(parameters_size) +        //    
           TOSTRING(parameters_total)         //  
          );
  }
#undef TOSTRING3
#undef TOSTRING2
#undef TOSTRING
};

#undef INT64
#undef DWORD
#undef UINT