#include "String.mqh"

#define UINT uint
#define DWORD int
#define INT64 datetime
#define UINT16 short

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
struct TestCacheHeader
{
  UINT              version;                //  
  //   wchar_t           copyright[64];          // 
  STRING64           copyright;             // 
//  wchar_t           name[16];               //   "TesterOptCache"
  STRING16           name   ;               //   "TesterOptCache"
  int               head_reserve[66];
   //---
  UINT              header_size;            //  
  UINT              record_size;            //    (TestCacheRecord   )
  //---
  //   wchar_t           expert_name[64];        //  
  STRING64           expert_name;           //  
  //   wchar_t           expert_path[128];       //      MQL5
  STRING128           expert_path;           //      MQL5
  //   wchar_t           server[64];             //   ( )
  STRING64           server;                //   ( )
  //   wchar_t           symbol[32];             //  
  STRING32           symbol;                //  
  UINT16            period;                 //  
  INT64             date_from;              //      
  INT64             date_to;                //     
  INT64             date_forward;           //    
  int               opt_mode;               //   (0- , 1-, 2  3-)
  int               ticks_mode;             //   
  int               last_criterion;         //     
  DWORD             msc_min;                //     
  DWORD             msc_max;                //     
  DWORD             msc_avg;                //     
  int               common_reserve[16];
  //---
  //   wchar_t           group[80];              //   + hedging/netting
  STRING80           group;                 //   + hedging/netting
  //   wchar_t           trade_currency[32];     //  
  STRING32           trade_currency;        //  
  int               trade_deposit;          //  
  int               trade_condition;        //    (0- , -1- , nnn- )
  int               trade_leverage;         // 
  int               trade_hedging;          // 1 - netting, 2 - hedging
  int               trade_currency_digits; //        
  int               trade_pips;             //   
  int               trade_reserve[5];
  //---
  char              hash_ex5[16];           //    
  UINT              parameters_size;        //    
  UINT              parameters_total;       //  
  UINT              opt_params_size;        //     
  UINT              opt_params_total;       //   
  UINT              dwords_cnt;             //     
  UINT              snapshot_size;          //           
  UINT              passes_total;           //     (   0)
  UINT              passes_passed;          //   
  //      ( .. )   TestCacheInput
  //---  .      

#define TOSTRING(A) #A + " = " + (string)(this.A) + "\n"
#define TOSTRING2(A) #A + " = " + ::EnumToString(A) + "\n"
#define TOSTRING3(A) #A + " = " + this.A[] + "\n"

  string ToString( void ) const
  {
    return(
           TOSTRING(version) +                //  
           TOSTRING3(copyright) +             // 
           TOSTRING3(name) +                  //   "TesterOptCache"
           TOSTRING(header_size) +            //  
           TOSTRING(record_size) +            //    (TestCacheRecord   )
           TOSTRING3(expert_name) +           //  
           TOSTRING3(expert_path) +           //      MQL5
           TOSTRING3(server) +                //   ( )
           TOSTRING3(symbol) +                //  
           TOSTRING2((ENUM_TIMEFRAMES)period) +                //  
           TOSTRING(date_from) +              //      
           TOSTRING(date_to) +                //     
           TOSTRING(date_forward) +           //    
           TOSTRING(opt_mode) +               //   (0- , 1-, 2  3-)
           TOSTRING(ticks_mode) +             //   
           TOSTRING(last_criterion) +         //     
           TOSTRING(msc_min) +                //     
           TOSTRING(msc_max) +                //     
           TOSTRING(msc_avg) +                //     
           TOSTRING3(group) +                 //   + hedging/netting
           TOSTRING3(trade_currency) +        //  
           TOSTRING(trade_deposit) +          //  
           TOSTRING(trade_condition) +        //    (0- , -1- , nnn- )
           TOSTRING(trade_leverage) +         // 
           TOSTRING(trade_hedging) +          // 1 - netting, 2 - hedging
           TOSTRING(trade_currency_digits) +  //        
           TOSTRING(trade_pips) +             //   
           TOSTRING(parameters_size) +        //    
           TOSTRING(parameters_total) +       //  
           TOSTRING(opt_params_size) +        //     
           TOSTRING(opt_params_total) +       //   
           TOSTRING(dwords_cnt) +             //     
           TOSTRING(snapshot_size) +          //           
           TOSTRING(passes_total) +           //     (   0)
           TOSTRING(passes_passed)            //   
          );
  }
#undef TOSTRING3
#undef TOSTRING2
#undef TOSTRING
};

/*
   m_header.header_size=sizeof(TestCacheHeader)+m_inputs.Total()*sizeof(TestCacheInput)+m_header.parameters_size;
//---      (  -   ),    ( ,  1 double),      
   m_header.record_size=sizeof(INT64)+m_header.opt_params_size;
   if(m_mathematics)
      m_header.record_size+=sizeof(double);
   else
      m_header.record_size+=sizeof(ExpTradeSummary);
   if(m_header.dwords_cnt>1)
      m_header.record_size+=m_header.dwords_cnt*sizeof(DWORD);
   else
     {
      if(m_genetics)
         m_header.record_size+=sizeof(INT64);
     }
*/

#undef UINT16
#undef INT64
#undef DWORD
#undef UINT